#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""python pac currency converter."""

# imports ####################################################################

import sys

from Tkinter import *
root = Tk()

sys.path.append("..")
import PAC


# PAC representation of a value ##############################################

class ValueP(PAC.Presentation):
	"""generic value presentation."""
	
	def __init__(self, controller=None):
		PAC.Presentation.__init__(self, controller)
		frame = Frame(root)
		frame.pack(expand=True, fill=X)
		
		label = Label(frame, text="€")
		label.pack(side=RIGHT, fill=BOTH)
		
		self.entry = Entry(frame, justify=RIGHT)
		self.entry.pack(expand=True, fill=BOTH)
		self.entry.bind("<Return>", self.validate)
		
	def validate(self, _):
		self.controller.amount = self.value
		
	def get_value(self):
		return float(self.entry.get())
	def set_value(self, v):
		self.entry.delete(0, END)
		self.entry.insert(0, v)
	value = property(get_value, set_value)
	

class MoneyA(PAC.Abstraction):
	"""Money abstraction."""
	
	def __init__(self, controller=None, amount=0):
		PAC.Abstraction.__init__(self, controller)
		self._amount = amount
		
	def get_amount(self):
		return self._amount
	def set_amount(self, amount):
		self._amount = amount
		self.controller.update()
	amount = property(get_amount, set_amount)
		
		
class MoneyC(PAC.Controller):
	"""money controller."""
	
	def __init__(self, parent=None):
		PAC.Controller.__init__(self,
		                        parent=parent,
		                        abstraction=MoneyA(self),
		                        presentation=ValueP(self))
		self.update()
		
	def update(self):
		self.presentation.value = self.amount
		
	def get_amount(self): 
		return self.abstraction.amount
	def set_amount(self, amount): 
		self.abstraction.amount = amount
	amount = property(get_amount, set_amount)
	
	
def _test():
	euro = MoneyC()
	return root.mainloop()
	
if __name__ == "__main__":
	sys.exit(_test())
	
		
